Program t37_4;

type
 tmatrix = array[1..100,1..100] of byte;

var
  infile, outfile : text;

  matrix1,
  tmpmatrix   : tmatrix;
  cx,  cy,
  fx,  fy,
  wdt, hgt    : byte;
  kirpcnt,
  kirp        : integer;

procedure findfree( mx : tmatrix; x, y : byte; var xfree, yfree : byte );
var
  cntx, cnty : byte;
Begin
 xfree := 0;
 yfree := 0;

 if x<wdt then
  if (mx[x,y]=0) and (mx[x+1,y] = 0) and (matrix1[x,y] <> matrix1[x+1,y]) then begin
    xfree := x+1;
    yfree := y;
    exit;
  end;
 if y<hgt then
  if (mx[x,y]=0) and (mx[x,y+1] = 0) and (matrix1[x,y] <> matrix1[x,y+1]) then begin
    xfree := x;
    yfree := y+1;
    exit;
  end;

 if x>1 then
  if (mx[x,y]=0) and (mx[x-1,y] = 0) and (matrix1[x,y] <> matrix1[x-1,y])then begin
    xfree := x-1;
    yfree := y;
    exit;
  end;
 if y>1 then
  if (mx[x,y]=0) and (mx[x,y-1] = 0) and (matrix1[x,y] <> matrix1[x,y-1]) then begin
    xfree := x;
    yfree := y-1;
    exit;
  end;
End;

Begin
 assign( infile, 'input.txt' );
 reset( infile );
 assign( outfile, 'output.txt' );
 rewrite( outfile );

 readln( infile, hgt, wdt );
 for cy := 1 to hgt do begin
  for cx := 1 to wdt do begin
    read( infile, matrix1[cx, cy] );
  end;
  readln( infile );
 end;

 kirp := (wdt*hgt) div 2;
 fillchar( tmpmatrix, sizeof(tmpmatrix), 0 );
 kirpcnt := 1;

 for cy := 1 to hgt do begin
  for cx := 1 to wdt do begin
    findfree( tmpmatrix, cx,cy, fx,fy );
    if (fx>0) and (fy>0) then begin
      tmpmatrix[ cx,cy ] := kirpcnt;
      tmpmatrix[ fx,fy ] := kirpcnt;
      inc( kirpcnt );
    end;
  end;
 end;

  if kirpcnt-1 < kirp then begin
    writeln( outfile, '-1' );
  end else begin
   for cy := 1 to hgt do begin
     for cx := 1 to wdt do begin
       write( outfile, tmpmatrix[cx,cy],' ');
     end;
     writeln( outfile );
   end;
  end;

 close( infile );
 flush( outfile );
 close( outfile );
End.
